/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package mammothcopy;

import java.io.*;
import java.security.*;

/**
 *
 * @author bart
 *
 * Stuff that can come in handy, but is too small to go in an own class.
 */
public class Generic {
    static final long TERA = 1000000000000L;
    static final long GIGA = 1000000000L;
    static final long MEGA = 1000000L;
    static final long KILO = 1000L;

    static String toHex(String s) {
	return toHex(s.getBytes());
    }
    static String toHex(byte[] s) {
	StringBuilder str = new StringBuilder();

	for (byte b : s) {
	    if ((b & 0xf0) == 0) {
		str.append("0");
	    }
	    str.append(Integer.toHexString(0xff & b));
	}

	return str.toString();
    }

    static String toHash(byte[] in, MessageDigest md) {
	String r = null;

	try {
	    md.reset();
	    md.update(in);
	    r = toHex(md.digest());
	} catch (Exception e) {
	    MammothCopyView.Log("Exception in hashing a string: "+e, MammothCopyView.LEVEL_ERROR);
	}

	return r;
    }

    static String toHash(String in, MessageDigest md) {
	return toHash(in.getBytes(), md);
    }

    // handy to translate big numbers in k, M, G, T
    static String toHumanReadable(long number) {
	String r = "";

	if (number > TERA) {
	    r = (number / TERA)+"T";
	} else if (number > GIGA) {
	    r = (number / GIGA)+"G";
	} else if (number > MEGA) {
	    r = (number / MEGA)+"M";
	} else if (number > KILO) {
	    r = (number / KILO)+"k";
	} else {
	    r = ""+number;
	}
	return r;
    }

    // Make sure the directory of the referred file
    // exists. If not, recursively create it.
    static boolean FixRelativeDirectory(File f) {
	boolean result = false;

	// the parent is probably a dir
	File parent = f.getParentFile();
	
	if (!parent.isDirectory()) {
	    MammothCopyView.Log("Parent is not a directory, creating: "+parent.getAbsolutePath(), MammothCopyView.LEVEL_NOTICE);
	    result = parent.mkdirs();
	} else {
	    result = true;
	}

	return result;
    }
}
