/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package mammothcopy;

import java.security.*;
import java.io.*;

/**
 *
 * @author bart
 */
public class MammothFile extends File {
    private String hash;

    final static int HASH_BUFFER = 4096;

    MammothFile(String _f, MessageDigest md) {
    	super(_f);

	try {
	    // calculate the file's hash and save it
	    FileInputStream s = new FileInputStream(this);
	    byte[] buffer = new byte[HASH_BUFFER];
	    md.reset();
	    int readbytes = 0;
	    while ((readbytes = s.read(buffer)) != -1) {
		md.update(buffer, 0, readbytes);
	    }
	    s.close();
	    hash = Generic.toHex(md.digest());
	} catch (FileNotFoundException e) {
	    MammothCopyView.Log("File is new: "+_f, MammothCopyView.LEVEL_NOTICE);
	} catch (Exception e) {
	    MammothCopyView.Log("Could not instantiate MammothFile: "+e.toString(), MammothCopyView.LEVEL_ERROR	);
	}
    }

    public String hash() {
	return hash;
    }
}
