/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package mammothcopy;

import java.net.*;
import java.io.*;


/**
 *
 * @author bart
 */
public class MammothServer extends Thread {
    int port;
    InetAddress address;

    ServerSocket theServer;
    String status;

    public boolean ServerRunning;

    MammothServer(int p, InetAddress addr) {
        MammothCopyView.Log("port: "+p+", ip: "+addr.toString(), MammothCopyView.LEVEL_NOTICE);

        try {
            theServer = new ServerSocket(p, 1, addr);
            MammothCopyView.setMyStatus("Idle");
        } catch (IOException e) {
            // some error.
            MammothCopyView.Log("Exception in ServerSocket "+e.toString(), MammothCopyView.LEVEL_ERROR);
            MammothCopyView.setMyStatus("Error: "+e.toString());
            theServer = null;
        } catch (Exception e) {
            MammothCopyView.Log("Exception in ServerSocket "+e.toString(), MammothCopyView.LEVEL_ERROR);
            MammothCopyView.setMyStatus("Error: "+e.toString());
            theServer = null;
        }
    }

    public void Stop() {
        ServerRunning = false;
        try {
            theServer.close();
            MammothCopyView.Log("Server stopped.", MammothCopyView.LEVEL_NOTICE);
            MammothCopyView.setMyStatus("Idle");
        } catch (IOException e) {
            MammothCopyView.Log("Error on closing server socket: "+e.toString(), MammothCopyView.LEVEL_ERROR);
            MammothCopyView.setMyStatus( "Error: "+e.toString());
        }
    }

    public String getStatus() {
        return status;
    }

    public void run() {
        if (theServer != null) {
            int i = 0;
            MammothCopyView.setMyStatus("Server started on IP "+theServer.getInetAddress().getHostAddress()+", port "+theServer.getLocalPort());
            MammothCopyView.Log("Server started on IP "+theServer.getInetAddress().getHostAddress()+", port "+theServer.getLocalPort(), MammothCopyView.LEVEL_NOTICE);
            ServerRunning = true;

            while (ServerRunning) {
                Socket client = null;
                try {
                    client = theServer.accept();

                    if (MammothCopyView.IsConnected() == true) {
                        PrintWriter out = new PrintWriter(client.getOutputStream(), true);
                        out.println("Already connected.\n");
                        client.close();
                    } else {
                        MammothCopyView.Connected(client);
                    }
                } catch (IOException e) {
                    // not really interesting, this also fires on a 'Stop' of the server
//                    MammothCopyView.Log("accept() failed: "+e.toString());
//                    MammothCopyView.setMyStatus("accept() failed: "+e.toString());
                }
            }
        } else {
            MammothCopyView.Log("Server not started: Server object was never correctly instantiated.", MammothCopyView.LEVEL_ERROR);
        }
    }
}
