/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package mammothcopy;

/**
 *
 * @author bart
 */
public class MammothTelegram {
    static final int PROT_OK = 0;
    static final int PROT_UNKNOWN = -1;
    static final int PROT_ERROR = -2;
    static final int PROT_UNSUPPORTED = -3;
    static final int PROT_EMPTY = -4;

    // handshake statuses
    static final int PROT_HS_REQ = 100;
    static final int PROT_HS_ACK = 101;
    static final int PROT_HS_NAK = 104;

    static final int PROT_RTS_RTS = 200;
    static final int PROT_RTS_NOMATCH = 201;
    static final int PROT_RTS_DISKFULL = 203;
    static final int PROT_RTS_FILENEW = 205;
    static final int PROT_RTS_FILEDONE = 206;
    static final int PROT_RTS_PARTDONE = 207;
    static final int PROT_RTS_NOPERM = 208;

    static final int PROT_CHUNK_CHUNK = 300;
    static final int PROT_CHUNK_DISKFULL = 302;
    static final int PROT_CHUNK_NOMATCH = 308;
    static final int PROT_CHUNK_DONE = 309;

    public int status;
    public String command;
    public String[] data;

    MammothTelegram(String c) {
	try {
	    if (c == null) {
		command = "";
	        status = PROT_EMPTY;
	    } else {
		String [] parts;
		// TODO: Parse files that have a ':' in their name
		parts = c.split(":");
		command = "";

		// first, get the command and status
		if (parts.length >= 2) {
		    command = parts[0];
		    status = Integer.parseInt(parts[1]);
		}

		// then parse status and fetch data
		if (command.equals("HS")) {
		    data = new String[2];
		    if (status == PROT_HS_REQ) {
			data[0] = parts[2];	    // requested hash function
			data[1] = parts[3];	    // chunksize
		    }
		} else if (command.equals("CHUNK")) {
		    if (status == PROT_CHUNK_CHUNK) {
			data = new String[3];
			data[0] = parts[2];	    // filename
			data[1] = parts[3];	    // number
			data[2] = parts[4];	    // hash
		    }
		} else if (command.equals("RTS")) {
		    data = new String[3];
		    data[0] = parts[2];		    // filename
		    if (status == PROT_RTS_PARTDONE) {
			// file is partially done, fetch last correctly received
			// chunk
			data[1] = parts[3];	    // last chunk
		    }
		    if (status == PROT_RTS_RTS) {
			data[1] = parts[3];	    // filesize
			data[2] = parts[4];	    // hash
		    }
		} else {
		    // command not supported.
		    status = PROT_UNSUPPORTED;
		}
	    }
	} catch (Exception e) {
	    MammothCopyView.Log("Couldn't parse telegram '"+c+"': "+e, MammothCopyView.LEVEL_ERROR);
	    command = "";
	    status = PROT_ERROR;
	}
    }
    MammothTelegram(String c, int s) {
        command = c;
        data = null;
        status = s;
    }

    @Override public String toString() {
	String s;
	
	s = "(MammothTelegram: cmd="+command+"; status="+status+")";

	return s;
    }


}
